DECLARE FUNCTION Rel.Point% (VideoBuf%(), X%, Y%)
DECLARE SUB Rel.Put (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE SUB Rel.PutN (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE SUB Rel.LoadPal (File$, PalString$, Switch%)
DECLARE SUB Rel.PageInit (VideoBuf%(), Xmax%, Ymax%)
DECLARE SUB SwitchHeroes (Active%, OldActive%)
DECLARE SUB DrawStatBar (VideoBuf%(), TempBuf%(), Spr AS ANY)
DECLARE SUB Init.StatBars ()
DECLARE SUB Init ()
DECLARE SUB Rel.CopyPage (DestBuffer%(), SrcBuffer%())
DECLARE SUB Init.Heroes ()
DECLARE SUB InitStats ()
DECLARE SUB DrawStats (VideoBuf%(), X%, Y%, Status AS ANY)
DECLARE SUB DrawHeroesOnStat ()
DECLARE FUNCTION Rel.Collide% (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE SUB Rel.Box (VideoBuf%(), X1%, Y1%, X2%, Y2%, CLR%)
DECLARE SUB Rel.PageCls (VideoBuf%(), CLR%)
DECLARE SUB Rel.NegativePal ()
DECLARE SUB Rel.Fade (R%, G%, B%, Counts%)
DECLARE SUB Rel.FadeToPal (PalString$, Counts%)
DECLARE SUB Rel.SetActivePage (VideoBuf%())
DECLARE SUB Rel.Font (VideoBuf%(), X%, Y%, Text$, Centered%, FontArray%(), FontArrayIndex%())
DECLARE SUB Rel.BoxT (VideoBuf%(), X1%, Y1%, X2%, Y2%, CLR%)
DECLARE SUB Rel.BoxFT (VideoBuf%(), X1%, Y1%, X2%, Y2%, CLR%)
DECLARE SUB Rel.AddByte (IntVal%, LowByte%, HiByte%, ByteFlag%)
DECLARE FUNCTION Rel.FastKB% ()
DECLARE SUB Rel.Sprite (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE SUB Rel.SpriteN (VideoBuf%(), X%, Y%, Sprite%(), SpriteOffset%)
DECLARE SUB Engine.DrawScreen ()
DECLARE SUB Engine.UpdatePlayer (Player AS ANY, Direction%)
DECLARE SUB Main ()
DECLARE SUB LoadTiles ()
DECLARE SUB LoadNPC ()
DECLARE SUB Engine.UpdateCamera (Level AS ANY, Player AS ANY)
DECLARE SUB InitVariables ()
DECLARE SUB InitMap ()
DECLARE SUB Engine.DrawMap ()
DECLARE SUB Engine.DrawPlayer (Player AS ANY)
DECLARE FUNCTION Engine.TileCollide% (Player AS ANY)
DECLARE SUB InitImageData (FileName$, ImageArray%())
DECLARE SUB MakeImageIndex (ImageArray%(), IndexArray%())
DECLARE FUNCTION Rel.Size% (X1%, Y1%, X2%, Y2%)
DECLARE SUB Rel.LineT (VideoBuf%(), X%, Y%, X2%, Y2%, CLR%)
DECLARE SUB Rel.Line (VideoBuf%(), X%, Y%, X2%, Y2%, CLR%)
DECLARE SUB Rel.ReadPal (PalString$)
DECLARE SUB Rel.ReadRGB (ColorVal%, R%, G%, B%)
DECLARE SUB Rel.WriteRGB (ColorNum%, R%, G%, B%)
DECLARE SUB Rel.LoadPalPp256 (File$)
DECLARE SUB Rel.Init (Xmax%, Ymax%)
DECLARE SUB Rel.PageCapture (VideoBuf() AS INTEGER)
DECLARE SUB Rel.PageVideoCopy (X%, Y%, VideoBuf%(), Action%)

'/==================PURE QB CODE 13H PAGE DOUBLE BUFFERING===================
'FAST ENOUGH FOR MOST PURPOSES.....
'I made this Routines except pp256 Routines by Chris Chadwick
'This Demo is a pure QB code example of screen 13 page emulation
'I took the initiative to make this for 2 reasons....
'1. A post from QB45.Com's forum and
'2. I'm planning a to make an RPG and/or Tutorial using this Routines.
'3. Demand from Purists to make a fast enough flickerless pureQB games.

'Author: RICHARD ERIC M. LOPE aka Relsoft(Philippines)
'Degree: Bachelor of Science in Nursing
'Email:  vic_viperph@yahoo.com
'Site: Http//Auraflow.Curvehead.com

'/======Disclaimer=============
'The Author is in no way liable for any damage done to your computer.
'Use/Abuse the code/Routines freely(though would like it if I'm credited...hehehehe)

DEFINT A-Z              'my first command on all my progs(speed)

TYPE SpriteType
         id             AS INTEGER              'ID
         Nick           AS STRING * 10
         X              AS INTEGER              'World X pos
         Y              AS INTEGER
         Xv             AS INTEGER              'X Speed
         Yv             AS INTEGER              'Y speed
         Frame          AS INTEGER              'Frame in tile where to draw
         BaseFrame      AS INTEGER
         Active         AS INTEGER
         Direction      AS INTEGER              'we will use this :)
         TileX          AS INTEGER              'Tile where the Player is on
         TileY          AS INTEGER
         Move           AS INTEGER
         Rank           AS STRING * 10
         Armor          AS STRING * 10
         Arms           AS STRING * 10
         Item           AS STRING * 10
         Level          AS INTEGER
         HP             AS INTEGER
         MP             AS INTEGER
         HPMax          AS INTEGER
         MPMax          AS INTEGER
         Strength       AS INTEGER
         Agility        AS INTEGER
         Intellect      AS INTEGER
         Experience     AS LONG
END TYPE

TYPE LevelType
        Xmax    AS INTEGER          'Maximum Number of Tiles a Map has
        Ymax    AS INTEGER
        CamX    AS INTEGER          'Pixel*Pixel Camera Position
        CamY    AS INTEGER
        TileX   AS INTEGER          'Tile postion of Camera
        TileY   AS INTEGER          'Calculated by CAMX\TileSize(16*16)
        Xpos    AS INTEGER          'Pixel position Inside the Tile
        Ypos    AS INTEGER          '0 to 15 (used for Scrolling)
        PxlXmax AS INTEGER
        PxlYmax AS INTEGER
END TYPE


TYPE MapLayerType
       BaseCollision  AS INTEGER       'Low Base , Hi Collision
       Fringe         AS INTEGER       'Low static,Hi anim
END TYPE

TYPE ScreenType
        Xmax    AS INTEGER
        Ymax    AS INTEGER
END TYPE



'========Declare constants here
CONST NULL = 0
CONST FALSE = 0, TRUE = NOT FALSE
'KeyBoard
CONST KEYRIGHT = 77, KEYLEFT = 75, KEYDOWN = 80, KEYUP = 72
CONST KEYESC = 1, KEYENTER = 28, KEYSPACE = 57, KEYTAB = &HF

'Use constants for speed!!!! :)

'Screen constants(Full Screen 320*200)
CONST ScrnXmax = 176, ScrnYmax = 160
CONST ScrnXmid = 80, ScrnYmid = 70
CONST ScrnXmin = 0, ScrnYmin = 0

'Tile dimensions 20*20
CONST TileW = 16                ' I just changed this LOL
CONST TileH = 16

CONST TileWT = 15
CONST TileHT = 15

CONST ULI = 0, ANYA = 1, ADIGUN = 2, EEBRO = 3



'Number of Tiles per screen 320\20=16,200\20=10
'Used to calculate the DrawMap sub
CONST ScrnTileXmax = ScrnXmax \ TileW
CONST ScrnTileYmax = ScrnYmax \ TileH

'Map Dimensions change this to suit your needs
CONST MapXmax = 35, MapYmax = 26

'Directional constants for easy sprite handling
'DN=Neutral(not Moving), DR=Right...........
CONST DN = 0, DR = 1, DU = 2, DL = 3, DD = 4


REM $STATIC
'This  Array is very important as they are here to speed things up.
DIM SHARED YsegLUT(199) AS LONG
DIM SHARED Scr AS ScreenType


REM $DYNAMIC

REDIM SHARED Vpage(1) AS INTEGER     'our page
REDIM SHARED Vpage2(1) AS INTEGER    'Bottom Stat
REDIM SHARED Vpage3(1) AS INTEGER    'Left Stat
REDIM SHARED Vpage4(1) AS INTEGER    'Right Stat
REDIM SHARED VpageTemp(1) AS INTEGER    'Bottom Temp for speed


'========Declare Arrays here
REDIM SHARED Map(MapXmax, MapYmax) AS MapLayerType           '36*27 map

'Tiles and Sprites 16*16
'Note the (1 to 1) since if you Dim it like (1) then it would be 0 to 1
'and errors would occur :)
REDIM SHARED BaseTile(1 TO 1) AS INTEGER
REDIM SHARED BaseTileIndex(1 TO 1)  AS INTEGER
REDIM SHARED FringeTile(1 TO 1) AS INTEGER
REDIM SHARED FringeTileIndex(1 TO 1)  AS INTEGER
REDIM SHARED Fringe2Tile(1 TO 1) AS INTEGER
REDIM SHARED Fringe2TileIndex(1 TO 1)  AS INTEGER



REDIM SHARED Sprite(1 TO 1) AS INTEGER
REDIM SHARED SpriteIndex(1 TO 1) AS INTEGER

REDIM SHARED Font(1 TO 1) AS INTEGER
REDIM SHARED FontIndex(1 TO 1)  AS INTEGER





'=========Level array
DIM SHARED Level AS LevelType
DIM SHARED Hero(3) AS SpriteType   'Our Hero
DIM SHARED Path$                'This is used to locate the dir of your files
DIM SHARED Starttime&
DIM SHARED RGBpal AS STRING * 768
DIM SHARED VsyncOn AS INTEGER
DIM SHARED ActiveHero

Init
Main                    'Main Loop

Rel.NegativePal
Rel.Fade 63, 45, 63, 100
Rel.Fade 0, 0, 0, 100

END


'Map Data
'I put this in a data statement since its easier to understand that way
' :)  you could put this in a file if you want
'Dimensions : 36*27
'Note: Col(X) #36 and Row(Y) #27 is not used by the Map. They are there for
'Padding purposes and to prevent errors.


MapDATABase:
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,04,04,04,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,06,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,04,04,04,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,06,06,06,01,01,01,01,01,01,01,01,01,01,01,01,01,01,04,04,04,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,06,06,06,06,06,01,01,01,01,01,01,01,01,01,01,04,04,04,04,04,04,04,04,04,01,01,01,01,01
DATA 01,01,01,01,01,01,06,06,06,06,06,06,06,01,01,01,05,01,01,01,01,01,04,04,04,04,04,04,04,04,04,01,01,01,01,01
DATA 01,01,01,01,01,01,01,06,06,06,06,06,01,01,01,01,05,01,01,01,01,01,04,04,04,04,04,04,04,04,04,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,06,06,06,01,01,01,01,05,05,05,01,01,01,01,01,01,01,04,04,04,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,06,01,01,01,01,01,05,05,05,01,01,01,01,01,01,01,04,04,04,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,05,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,05,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,03,03,03,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,03,03,03,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,03,01,01,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,02,02,02,02,02,02,02,02,01,01,01,01,01,03,03,03,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,02,02,02,02,02,02,01,01,01,01,01,01,03,03,03,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,02,02,02,02,01,01,01,01,01,01,01,03,01,03,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,02,02,02,02,02,02,01,01,01,01,01,01,03,01,03,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,02,02,02,02,02,02,02,02,01,01,01,01,01,03,01,01,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,03,01,01,03,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01
DATA 01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01,01

'0= no collision           'Fringe
'1= no collision           'Tilt
'2= collision              'Fringe
'3= collision              'Tilt
'TRY TO RUN THE RPG AND CHECK THE FIRST COLUMN FOR DIFFERENT COLLISION TYPES
'SORRY AS I WAS TO ;AZY TO MAKE A MAP ED SO THE MAP SUX.
MapDATACollision:
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 02,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 03,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 01,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 02,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 03,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00


MapDATAFringe:
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,28,28,28,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,29,00,30,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,37,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,31,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 15,00,00,00,00,00,00,00,00,00,00,00,00,00,32,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 15,00,00,00,00,00,00,00,00,00,00,00,00,00,33,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 15,00,00,00,00,00,00,00,00,00,00,00,00,00,00,12,32,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,38,00,00,00,00,00,00,33,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,23,00,33,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,23,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,32,33,18,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,33,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,37,00,00,00,00,00,00,00,14,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,37,00,00,00,00,00,00,00,00,00,00,00,30,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,38,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,17,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00

MapDATAFringe2:
DATA 00,00,00,00,00,00,00,05,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 09,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 09,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 09,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 09,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,05,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,09,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,13,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 09,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00
DATA 00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00

REM $STATIC
SUB DrawHeroesOnStat
'Variables to help me
Xmax = 71
Ymax = 159
Box1 = 3
Box2 = 81

Rel.SetActivePage Vpage3()              'Set the active page to 3

'Uli
DrawStats Vpage3(), 4, Box1, Hero(0)    'Draw our statbar

'Anya
DrawStats Vpage3(), 4, Box2, Hero(1)

Rel.SetActivePage Vpage4()

'Adigun
DrawStats Vpage4(), 4, Box1, Hero(2)

'Eebro
DrawStats Vpage4(), 4, Box2, Hero(3)

Rel.PageVideoCopy 0, 0, Vpage3(), 1             'Pcopy both statbars to
Rel.PageVideoCopy 248, 0, Vpage4(), 1           'Screen(Right and Left)

Rel.SetActivePage Vpage()            'Set the active page to the main screen

END SUB

SUB DrawStatBar (VideoBuf(), TempBuf(), Spr AS SpriteType)

Rel.SetActivePage VideoBuf()
Xmax = Scr.Xmax
Ymax = Scr.Ymax
Rel.CopyPage VideoBuf(), TempBuf()

Rel.Sprite VideoBuf(), 3, 2, Sprite(), SpriteIndex(Spr.BaseFrame)  'Sprite
Rel.Font VideoBuf(), 25, 6, Spr.Nick, FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), 4, 23, "EXP: " + STR$(Spr.Experience), FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), 4, 31, "GP: " + "00000", FALSE, Font(), FontIndex()

Rel.Font Vpage2(), 73, 4, "PureQB RPG Engine <Http://AuraFlow.Curvehead.Com>", FALSE, Font(), FontIndex()
Rel.Font Vpage2(), 73, 13, "Coding: Richard Eric M. Lope aka RelSoft", FALSE, Font(), FontIndex()
Rel.Font Vpage2(), 73, 21, "Tiles/Coding: Achmad Aulia aka L_O_J", FALSE, Font(), FontIndex()
Rel.Font Vpage2(), 73, 29, "Fonts: Adigun Polack  Greets to: Eero Pitkanen aka Eebro/Ebr", FALSE, Font(), FontIndex()

Rel.PageVideoCopy 0, 160, VideoBuf(), 1

END SUB

SUB DrawStats (VideoBuf(), X, Y, Status AS SpriteType)

Rel.Sprite VideoBuf(), 4, Y, Sprite(), SpriteIndex(Status.BaseFrame)
Rel.Font VideoBuf(), 24, Y + 4, Status.Nick, FALSE, Font(), FontIndex()

HP$ = LTRIM$(STR$(Status.HP)) + " / " + LTRIM$(STR$(Status.HPMax))
MP$ = LTRIM$(STR$(Status.MP)) + " / " + LTRIM$(STR$(Status.MPMax))

Rel.Font VideoBuf(), X, Y + 20, "Rank: " + Status.Rank, FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), X, Y + 28, "Armor: " + Status.Armor, FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), X, Y + 36, "Arms: " + Status.Arms, FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), X, Y + 44, "Item: " + Status.Item, FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), X, Y + 52, "Level: " + STR$(Status.Level), FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), X, Y + 60, "HP: " + HP$, FALSE, Font(), FontIndex()
Rel.Font VideoBuf(), X, Y + 68, "MP: " + MP$, FALSE, Font(), FontIndex()

END SUB

SUB Engine.DrawMap STATIC

'==========BaseLayer====================
'Calculate the first tile to draw
Level.TileX = Level.CamX \ TileW        'First tile to draw
Level.TileY = Level.CamY \ TileH
                             
'Get the offset inside the tile
Level.Xpos = Level.CamX AND TileWT            'Position in the Tile(0 to 15)
Level.Ypos = Level.CamY AND TileHT            '16*16 tile size(change to fit your needs)

'Draw our Screen(No need to clear our Page)
FOR Y = 0 TO ScrnTileYmax         '11 tiles
       TY = (Y * TileH) - Level.Ypos
FOR X = 0 TO ScrnTileXmax         '16 tiles
        Tile = Map(X + Level.TileX, Y + Level.TileY).BaseCollision AND 255
        IF Tile > 0 THEN
        Rel.SpriteN Vpage(), ((X * TileW) - Level.Xpos), TY, BaseTile(), BaseTileIndex(Tile)
        END IF
NEXT X
NEXT Y


'Lower Fringe

'==========Fringe1Layer====================
'Use RelSprite
'Draw our Screen(No need to clear our Page)
FOR Y = 0 TO ScrnTileYmax         '11 tiles
       TY = (Y * TileH) - Level.Ypos
FOR X = 0 TO ScrnTileXmax         '16 tiles
        Tile = Map(X + Level.TileX, Y + Level.TileY).Fringe AND 255
        IF Tile > 0 THEN
        CTile = Map(X + Level.TileX, Y + Level.TileY).BaseCollision \ 256
        IF CTile <> 1 OR CTile <> 3 THEN
        Rel.Sprite Vpage(), ((X * TileW) - Level.Xpos), TY, FringeTile(), FringeTileIndex(Tile)
        END IF
        END IF
NEXT X
NEXT Y

'==========Fringe2Layer====================
'Use RelSprite
'Draw our Screen(No need to clear our Page)
DynaFrame = (DynaFrame + 1) AND 31
IF DynaFrame = 0 THEN TileFrame = (TileFrame + 1) AND 3
FOR Y = 0 TO ScrnTileYmax         '11 tiles
       TY = (Y * TileH) - Level.Ypos
FOR X = 0 TO ScrnTileXmax         '16 tiles
        Tile = Map(X + Level.TileX, Y + Level.TileY).Fringe \ 256
        IF Tile > 0 THEN
        CTile = Map(X + Level.TileX, Y + Level.TileY).BaseCollision \ 256
        IF CTile <> 1 OR CTile <> 3 THEN
        Rel.Sprite Vpage(), ((X * TileW) - Level.Xpos), TY, Fringe2Tile(), Fringe2TileIndex(Tile + TileFrame)
        END IF
        END IF
NEXT X
NEXT Y



Engine.DrawPlayer Hero(ActiveHero)  'Draw our Player to Page()




'==========ObjectLayer====================
'Use RelSprite

'Tilt layer

'==========Fringe1Layer====================
'Use RelSprite
'Draw our Screen(No need to clear our Page)
FOR Y = 0 TO ScrnTileYmax         '11 tiles
       TY = (Y * TileH) - Level.Ypos
FOR X = 0 TO ScrnTileXmax         '16 tiles
        Tile = Map(X + Level.TileX, Y + Level.TileY).Fringe AND 255
        IF Tile > 0 THEN
        CTile = Map(X + Level.TileX, Y + Level.TileY).BaseCollision \ 256
        IF CTile = 1 OR CTile = 3 THEN
        Rel.Sprite Vpage(), ((X * TileW) - Level.Xpos), TY, FringeTile(), FringeTileIndex(Tile)
        END IF
        END IF
NEXT X
NEXT Y

'==========Fringe2Layer====================
'Use RelSprite
'Draw our Screen(No need to clear our Page)
FOR Y = 0 TO ScrnTileYmax         '11 tiles
       TY = (Y * TileH) - Level.Ypos
FOR X = 0 TO ScrnTileXmax         '16 tiles
        Tile = Map(X + Level.TileX, Y + Level.TileY).Fringe \ 256
        IF Tile > 0 THEN
        CTile = Map(X + Level.TileX, Y + Level.TileY).BaseCollision \ 256
        IF CTile = 1 OR CTile = 3 THEN
        Rel.Sprite Vpage(), ((X * TileW) - Level.Xpos), TY, Fringe2Tile(), Fringe2TileIndex(Tile + TileFrame)
        END IF
        END IF
NEXT X
NEXT Y



END SUB

SUB Engine.DrawPlayer (Player AS SpriteType) STATIC

'Notes:
'1. Uses the Directional Constants defined at module level(DN,DR...)

'This Stops the Player from Swaying his arms very fast
'DirChanged=Is just a flag to prevent Electric legs effect and to see if
'Player changed direction

IF Player.Direction <> OldDir THEN      'if Player changes direction
        DirChanged = 1                  'Flag it to change BaseFrame
ELSE
        'Delays frame rotation for sprite(Electric legs :))
        DirChanged = (DirChanged + 1) AND 7      'Try to REM this :)
END IF

IF DirChanged = 1 THEN
IF Player.Move THEN                     'Flag if player has moved
        Player.Frame = (Player.Frame + 1) AND 3  'Frame=Current frame(1 to 3) the
                                        'Player sprite is
                                        'Frame is Added to baseFrame to locate
                                        'the True Sprite Offset
                                        'See PP256

        SELECT CASE Player.Direction
                CASE DR
                        'Calculate the Frame of the sprite to draw
                        Frame = Player.Frame + Player.BaseFrame + 8     'Base Frame=9
                CASE DU
                        Frame = Player.Frame + Player.BaseFrame + 12    'Base Frame=13
                CASE DL
                        Frame = Player.Frame + Player.BaseFrame + 4     'Base Frame=5
                CASE DD
                        Frame = Player.Frame + Player.BaseFrame       'Base Frame=1
                CASE ELSE
        END SELECT

        Player.Move = FALSE             'Stops the Player from Swaying
                                        'his arms while not moving
END IF
END IF

'Formula: X(same goes for Y)
'Player.X-Level.CamX
'just puts the player at the Center of screen
'So if Player.X=500 then CamX=Player.X-ScrnYmid(ScrnYmid=Middle of 320=160)
'CamX:500-160=340
'Player.X=500
'Xcenter:500-340=160(ScrnXmid)
'Same goes for Y
'See Engine.UpdateCamera for more Details :)
'Sprite(SpriteIndex(Sprite.Frame) is the current frame of the Sprite(calculated above)
'Notes:
'1.Sprite(SpriteIndex(Sprite.Frame))=Real offset of the frame(NO ERRORS)
'2.SpriteIndex(Sprite.Frame)=Index of the real offset of the frame(ERRORS)
IF Frame < Player.BaseFrame THEN Frame = Player.BaseFrame
Rel.Sprite Vpage(), (Player.X - Level.CamX), (Player.Y - Level.CamY), Sprite(), SpriteIndex(Frame)

OldDir = Player.Direction             'Save our Direction for checking above
                                      'OldDir is saved since we have declared
                                      'this SUB  as STATIC

END SUB

SUB Engine.DrawScreen STATIC
'Notes:
'Page() is a dynamic array we defined at module level for our page
Px = 72
Py = 0

Engine.DrawMap          'Draw our map to Page()


FPS = FPS + 1
IF Starttime& + 1 < TIMER THEN
 FPS2 = FPS
 FPS = 0
 Starttime& = TIMER
END IF

FreeMem& = FRE(-1)
Rel.BoxFT Vpage(), 2, 2, Scr.Xmax - 2, 18, 88
Rel.BoxT Vpage(), 0, 0, Scr.Xmax, 20, 31
Rel.BoxT Vpage(), 1, 1, Scr.Xmax - 1, 19, 28
Rel.Font Vpage(), 3, 3, "Fps:" + STR$(FPS2) + "  FRAME:" + STR$(Hero(0).Frame) + "  FreeMem" + STR$(INT(FreeMem&)), TRUE, Font(), FontIndex()
Rel.Font Vpage(), 3, 12, "<Enter>Vsynch:" + STR$(VsyncOn) + "       " + "<SpaceBar>Speed:" + STR$(Hero(ActiveHero).Xv), TRUE, Font(), FontIndex()

IF VsyncOn THEN
        WAIT &H3DA, 8
        WAIT &H3DA, 8, 8
END IF
Rel.PageVideoCopy Px, Py, Vpage(), 1

END SUB

FUNCTION Engine.TileCollide (Player AS SpriteType) STATIC
'Crappy tile*tile collision detection ;)
'Returns TRUE if collision is detected, FALSE if not
'I didn't include a Pixel*pixel colision detection so as not to be confusing
'RelLib has a Pixel*pixel collision detection so don't worry ;)

'Init the function to be FALSE(no collision)
Engine.TileCollide = FALSE


'4 checks are done to be sure ;)
'Up-Left corner of hero
X = Player.X + 4        'Add 1 for 20*20 Box Collision
Y = Player.Y + 8
GOSUB CheckForTile      'check for the tile

'Up-Right corner of hero
X = Player.X + 11
Y = Player.Y + 8
GOSUB CheckForTile

'Down-Right corner of hero
X = Player.X + 11
Y = Player.Y + 15
GOSUB CheckForTile

'Down-Left corner of hero
X = Player.X + 4
Y = Player.Y + 15
GOSUB CheckForTile


EXIT FUNCTION

'Check for collision:(Bounding BoxType)
CheckForTile:
TX = X \ TileW          'Player.X\TileW=TileX
TY = Y \ TileH          'Player.Y\TileH=TileH
IF Map(TX, TY).BaseCollision \ 256 > 1 THEN 'collision layer check
                Engine.TileCollide = TRUE
                EXIT FUNCTION
END IF
RETURN          'Check for next Coord


END FUNCTION

SUB Engine.UpdateCamera (Level AS LevelType, Player AS SpriteType) STATIC

'Updates CAMX,CAMY in relation to Player.X,Player.Y to achieve
'ZELDA style scrolling engine.
'Sample Code:
'CODE: CASE DR
        'Right Direction of movement
'CODE: Level.CamX = Player.X - ScrnXmid
        'Center our player and Moves the camera to where
        'the player is going
        'ie, Assume: Player.X=1200,ScrnMid=Constant 160(Middle screen)
        'Level.CamX:1200-160=1040
        'to get the TileX:
        'TileX=Level.CamX\TileW=1040\16=65(This will be used with Engine.DrawMap)
'CODE: IF Level.CamX < ScrnXmin THEN Level.CamX = ScrnXmin
        'Check if level.CamX<0, Zero it if its negative to prevent errors
        'ScrnYmin=0(Constant)
'CODE: IF Level.CamX > (Level.Xmax * TileW) - ScrnXmax THEN Level.CamX = (Level.Xmax * TileW) - ScrnXmax
        'Check if Level.CamX > (Level.Xmax * TileW) - ScrnXmax
        '(Level.Xmax * TileW) - ScrnXmax=Maximum number of PIXELS the Map has
        'Level.Xmax=Max num of tile for map(Shared Variable Level.Element)
        'TileW=Width of tile(Constant)
        'ScrnXmax=320(Constant)
        'To calculate: Level.Xmax=MapXmax
        'Formula:(Level.Xmax * TileW) - ScrnXmax
        'Level.Xmax=36
        '(36*16)-320=256
        'Level.CamX=256
        'To calculate TileX:
        'Level.CamX\TileW
        '256\16=16
        'TileX=16(Start Drawing from 16 to 36)
        '16 is the first tile to draw in X
        '36-16=20(See we have to draw 20 tiles horizontally!!!)
        'Same goes for Y
        'See Engine.DrawMap SUB for more details. ;)

SELECT CASE Player.Direction
        CASE DR
                Level.CamX = Player.X - ScrnXmid
                IF Level.CamX < ScrnXmin THEN Level.CamX = ScrnXmin
                IF Level.CamX > (Level.PxlXmax) - ScrnXmax THEN Level.CamX = (Level.PxlXmax) - ScrnXmax
        CASE DU
                Level.CamY = Player.Y - ScrnYmid
                IF Level.CamY < ScrnYmin THEN Level.CamY = ScrnYmin
                IF Level.CamY > (Level.PxlYmax) - ScrnYmax THEN Level.CamY = (Level.PxlYmax) - ScrnYmax
        CASE DL
                Level.CamX = Player.X - ScrnXmid
                IF Level.CamX < ScrnXmin THEN Level.CamX = ScrnXmin
                IF Level.CamX > (Level.PxlXmax) - ScrnXmax THEN Level.CamX = (Level.PxlXmax) - ScrnXmax
        CASE DD
                Level.CamY = Player.Y - ScrnYmid
                IF Level.CamY < ScrnYmin THEN Level.CamY = ScrnYmin
                IF Level.CamY > (Level.PxlYmax) - ScrnYmax THEN Level.CamY = (Level.PxlYmax) - ScrnYmax
        CASE ELSE
END SELECT


END SUB

SUB Engine.UpdatePlayer (Player AS SpriteType, Direction) STATIC
'Updates the players position according to its direction
'ZELDA style Pixel*Pixel free movement
'Sample Code:
'CODE: CASE DR
        'Direction of Player movement
'CODE: Player.X = Player.X + Player.XV
        'Add Xspeed to Player X position since we are moving right
'CODE: IF Engine.TileCollide(Hero) THEN Player.X = Player.X - Player.XV
        'Check for collision. If collided with valid "collidable" tile
        'Subtract Xspeed to return the player to its original place.
        'Also prevents player sticking to tiles when changing direction.
'CODE: IF Player.X > (Level.Xmax * TileW) - TileW THEN Player.X = (Level.Xmax * TileW) - TileW
        'Checks if player is outside of World map boudaries
        '(Level.Xmax * TileW) - TileW=(36*16)-16
        'Subracting 16(TileW) is necessary to prevent errors if your speed
        'is greater than 1. Also used for padding.

SELECT CASE Direction
        CASE DR
                Player.X = Player.X + Player.Xv
                IF Engine.TileCollide(Player) THEN Player.X = Player.X - Player.Xv
                IF Player.X > (Level.PxlXmax) - TileW THEN Player.X = (Level.PxlXmax) - TileW
        CASE DU
                Player.Y = Player.Y - Player.Yv
                IF Engine.TileCollide(Player) THEN Player.Y = Player.Y + Player.Yv
                IF Player.Y < ScrnYmin THEN Player.Y = ScrnYmin
        CASE DL
                Player.X = Player.X - Player.Xv
                IF Engine.TileCollide(Player) THEN Player.X = Player.X + Player.Xv
                IF Player.X < ScrnXmin THEN Player.X = ScrnXmin
        CASE DD
                Player.Y = Player.Y + Player.Yv
                IF Engine.TileCollide(Player) THEN Player.Y = Player.Y - Player.Yv
                IF Player.Y > (Level.PxlYmax) - TileH THEN Player.Y = (Level.PxlYmax) - TileH
        CASE ELSE
END SELECT

'Update the player moveFlag to animate the player(REM this for no Animation)
Player.Move = TRUE

'Calculate what Tile the player is
'Add 8 to X and Y to get center of Player since size is 16*16
Player.TileX = (Player.X + 8) \ TileW    'Center of Sprite
Player.TileY = (Player.Y + 8) \ TileH

END SUB

SUB Init


CLS
SCREEN 13
Path$ = "C:\Temp\MiniRpg\"   'CHANGE THIS TO THE DIR YOU UNZIPPED THE FILE
Path$ = ""   'CHANGE THIS TO THE DIR YOU UNZIPPED THE FILE


LoadTiles               'Load our Tileset
LoadNPC                 'Hero Sprite
InitMap                 'Read our Map Array(Data StateMents)
Rel.LoadPal Path$ + "Relpal.Pal", RGBpal, FALSE
Rel.Fade 0, 0, 0, 0



Rel.PageInit Vpage2(), 319, 39                       'Bottom Stat page
Rel.PageInit VpageTemp(), 319, 39                    'Bottom Stat page

Rel.PageInit Vpage3(), 71, 159                       'Left Stat page

Rel.PageInit Vpage4(), 71, 159                       'Right Stat page

Rel.PageInit Vpage(), ScrnXmax - 1, ScrnYmax - 1    'main Scroll page


InitVariables           'Initialize our variables
Init.StatBars

END SUB

SUB Init.Heroes
'Hero Starting Variables
'Center-down
ActiveHero = ULI

'Uli
Hero(0).id = 1
Hero(0).Nick = "Uli"
Hero(0).X = 2 * TileW
Hero(0).Y = 2 * TileH
Hero(0).Xv = 2
Hero(0).Yv = 2
Hero(0).Frame = 0
Hero(0).BaseFrame = 1
Hero(0).Active = TRUE
Hero(0).Direction = DU
Hero(0).TileX = 0
Hero(0).TileY = 0
Hero(0).Move = FALSE
Hero(0).Rank = "Samurai"
Hero(0).Armor = "Yoichi"
Hero(0).Arms = "Masmune"
Hero(0).Item = "Power Brc"
Hero(0).Level = 9
Hero(0).HP = 9999
Hero(0).MP = 9999
Hero(0).HPMax = 9999
Hero(0).MPMax = 9999
Hero(0).Strength = 99
Hero(0).Agility = 99
Hero(0).Intellect = 99
Hero(0).Experience = 0

'Anya
Hero(1).id = 1
Hero(1).Nick = "Anya"
Hero(1).X = 2 * TileW
Hero(1).Y = 2 * TileH
Hero(1).Xv = 2
Hero(1).Yv = 2
Hero(1).Frame = 0
Hero(1).BaseFrame = 17
Hero(1).Active = TRUE
Hero(1).Direction = DU
Hero(1).TileX = 0
Hero(1).TileY = 0
Hero(1).Move = FALSE
Hero(1).Rank = "Cevar"
Hero(1).Armor = "Crystal"
Hero(1).Arms = "Crystalis"
Hero(1).Item = "Polar Ring"
Hero(1).Level = 9
Hero(1).HP = 9999
Hero(1).MP = 9999
Hero(1).HPMax = 9999
Hero(1).MPMax = 9999
Hero(1).Strength = 99
Hero(1).Agility = 99
Hero(1).Intellect = 99
Hero(1).Experience = 0

'Adigun
Hero(2).id = 1
Hero(2).Nick = "Adigun"
Hero(2).X = 2 * TileW
Hero(2).Y = 2 * TileH
Hero(2).Xv = 2
Hero(2).Yv = 2
Hero(2).Frame = 0
Hero(2).BaseFrame = 1
Hero(2).Active = TRUE
Hero(2).Direction = DU
Hero(2).TileX = 0
Hero(2).TileY = 0
Hero(2).Move = FALSE
Hero(2).Rank = "Knight"
Hero(2).Armor = "Magic"
Hero(2).Arms = "GunBlade"
Hero(2).Item = "Ref. Shld"
Hero(2).Level = 9
Hero(2).HP = 9999
Hero(2).MP = 9999
Hero(2).HPMax = 9999
Hero(2).MPMax = 9999
Hero(2).Strength = 99
Hero(2).Agility = 99
Hero(2).Intellect = 99
Hero(2).Experience = 0

'Eebro
Hero(3).id = 1
Hero(3).Nick = "Eebro"
Hero(3).X = 2 * TileW
Hero(3).Y = 2 * TileH
Hero(3).Xv = 2
Hero(3).Yv = 2
Hero(3).Frame = 0
Hero(3).BaseFrame = 1
Hero(3).Active = TRUE
Hero(3).Direction = DU
Hero(3).TileX = 0
Hero(3).TileY = 0
Hero(3).Move = FALSE
Hero(3).Rank = "General"
Hero(3).Armor = "KevlarRED"
Hero(3).Arms = "PSG Rifle"
Hero(3).Item = "Bazooka!"
Hero(3).Level = 9
Hero(3).HP = 9999
Hero(3).MP = 9999
Hero(3).HPMax = 9999
Hero(3).MPMax = 9999
Hero(3).Strength = 99
Hero(3).Agility = 99
Hero(3).Intellect = 99
Hero(3).Experience = 0


END SUB

SUB Init.StatBars

Xmax = 71
Ymax = 159
'/LEFT Statbar
Rel.SetActivePage Vpage3()
FOR Y = 0 TO Ymax + 1 STEP 16
    FOR X = 0 TO Xmax + 1 STEP 16
        Rel.SpriteN Vpage3(), X, Y, BaseTile(), BaseTileIndex(6)
    NEXT X
NEXT Y
Rel.BoxFT Vpage3(), 0, 0, Xmax, Ymax, 170
Rel.Box Vpage3(), 0, 0, Xmax, Ymax, 28          'Borders
Rel.Box Vpage3(), 1, 1, Xmax - 1, Ymax - 1, 31
Rel.Box Vpage3(), 2, 2, Xmax - 2, Ymax - 2, 28

Rel.Line Vpage3(), 3, 78, Xmax - 2, 78, 28       'Midlines
Rel.Line Vpage3(), 3, 79, Xmax - 2, 79, 31
Rel.Line Vpage3(), 3, 80, Xmax - 2, 80, 28


'/RIGHT Statbar
Rel.CopyPage Vpage4(), Vpage3()                 'Code reduction :*)

'/Bottom statbar
Xmax = 319
Ymax = 39
Rel.SetActivePage Vpage2()
FOR I = 0 TO 320 STEP 16
        Rel.SpriteN Vpage2(), I, -4, BaseTile(), BaseTileIndex(5)
        Rel.SpriteN Vpage2(), I, 12, BaseTile(), BaseTileIndex(5)
        Rel.SpriteN Vpage2(), I, 28, BaseTile(), BaseTileIndex(5)
NEXT I

Rel.BoxFT Vpage2(), 2, 2, Xmax - 2, Ymax - 2, 145       'BG
Rel.Box Vpage2(), 0, 0, Xmax, Ymax, 28                  'Borders
Rel.Box Vpage2(), 1, 1, Xmax - 1, Ymax - 1, 31          '
Rel.Box Vpage2(), 2, 2, Xmax - 2, Ymax - 2, 28          '

Rel.Box Vpage2(), 69, 3, 69, Ymax - 3, 28         'Pic Divider
Rel.Box Vpage2(), 70, 3, 70, Ymax - 3, 31
Rel.Box Vpage2(), 71, 3, 71, Ymax - 3, 28

Rel.CopyPage VpageTemp(), Vpage2()

DrawHeroesOnStat
DrawStatBar Vpage2(), VpageTemp(), Hero(ActiveHero)




END SUB

'* InitImageData() subroutine:
'* Initializes an integer array with image data - this must be done before
'* displaying an image using the PUT(graphics) statement. The calling value
'* of FileName$ dictates whether the data should be read directly from an
'* image file or from DATA statements (see below).
'*
'* Parameters:
'*    FileName$ - The name of the image file to load. This must include the
'*                path to the file if it does not reside in the current
'*                directory. If FileName$ is an empty string (""), image
'*                data is read from DATA statements.
'* ImageArray() - Dynamic, integer array to hold the image data.
'*
'* Note: Before calling InitImageData() to initialize images from DATA
'*       statements, use an appropriate RESTORE statement to ensure the
'*       correct DATA statements are read.
'*
SUB InitImageData (FileName$, ImageArray())

    IF FileName$ <> "" THEN
        '***** Read image data from file *****

        'Establish size of integer array required.
        FileNo = FREEFILE
        OPEN FileName$ FOR BINARY AS #FileNo
        Ints = (LOF(FileNo) - 7) \ 2
        CLOSE #FileNo
        REDIM ImageArray(1 TO Ints)

        'Load image data directly into array memory.
        DEF SEG = VARSEG(ImageArray(1))
        BLOAD FileName$, 0
        DEF SEG
    ELSE
        '***** Read image data from DATA statements *****

        'Establish size of integer array required.
        READ IntCount
        REDIM ImageArray(1 TO IntCount)

        'READ image DATA into array.
        FOR n = 1 TO IntCount
            READ X
            ImageArray(n) = X
        NEXT n
    END IF


END SUB

SUB InitMap STATIC
RESTORE MapDATABase         'Read from Data label
FOR Y = 0 TO MapYmax
FOR X = 0 TO MapXmax
        READ Tile
        Rel.AddByte Map(X, Y).BaseCollision, Tile, 0, 1
NEXT X
NEXT Y


RESTORE MapDATACollision
FOR Y = 0 TO MapYmax
FOR X = 0 TO MapXmax
        READ Tile
        Rel.AddByte Map(X, Y).BaseCollision, 0, Tile, 2
NEXT X
NEXT Y


RESTORE MapDATAFringe         'Read from Data label
FOR Y = 0 TO MapYmax
FOR X = 0 TO MapXmax
        READ Tile
        Rel.AddByte Map(X, Y).Fringe, Tile, 0, 1
NEXT X
NEXT Y

RESTORE MapDATAFringe2         'Read from Data label
FOR Y = 0 TO MapYmax
FOR X = 0 TO MapXmax
        READ Tile
        Rel.AddByte Map(X, Y).Fringe, 0, Tile, 2
NEXT X
NEXT Y



END SUB

SUB InitVariables STATIC

Init.Heroes

'Initialize Level Data
'Start from Center-Down
Level.Xmax = MapXmax
Level.Ymax = MapYmax
Level.CamX = 0
Level.CamY = 0
Level.TileX = 0
Level.TileY = 0
Level.Xpos = 0
Level.Ypos = 0
Level.PxlXmax = TileW * Level.Xmax
Level.PxlYmax = TileH * Level.Ymax

Hero(ActiveHero).Direction = DU                     'Two directions so that engine will
Engine.UpdateCamera Level, Hero(ActiveHero)         'know where level TileX and TileY
Hero(ActiveHero).Direction = DR                     'Positions from left to right
Engine.UpdateCamera Level, Hero(ActiveHero)         'No warping ;)


END SUB

SUB LoadNPC
'Note the Path$ variable(Declared at module level)
File$ = Path$ + "HeroLoj.PUT"
InitImageData File$, Sprite()
MakeImageIndex Sprite(), SpriteIndex()

END SUB

SUB LoadTiles
'Note the Path$ var
File$ = Path$ + "Base.Put"
InitImageData File$, BaseTile()
MakeImageIndex BaseTile(), BaseTileIndex()

File$ = Path$ + "Fringe.Put"
InitImageData File$, FringeTile()
MakeImageIndex FringeTile(), FringeTileIndex()

File$ = Path$ + "FrgAnim.Put"
InitImageData File$, Fringe2Tile()
MakeImageIndex Fringe2Tile(), Fringe2TileIndex()


File$ = Path$ + "TinyFont.Put"
InitImageData File$, Font()
MakeImageIndex Font(), FontIndex()



END SUB

SUB Main STATIC

Rel.SetActivePage Vpage()

Engine.DrawScreen
Rel.FadeToPal RGBpal, 100

Finished = FALSE
DO
        Engine.DrawScreen               'Draw Our  Screen to page and
                                        'Copy it to VIDEO
        SELECT CASE Rel.FastKB
                CASE KEYESC
                        Finished = TRUE
                CASE KEYTAB
                        OldActiveHero = ActiveHero
                        ActiveHero = (ActiveHero + 1) AND 3
                        SwitchHeroes ActiveHero, OldActiveHero
                        DrawStatBar Vpage2(), VpageTemp(), Hero(ActiveHero)
                        Rel.SetActivePage Vpage()
                CASE KEYENTER
                        VsyncOn = NOT VsyncOn
                CASE KEYSPACE
                        Hero(ActiveHero).Xv = Hero(ActiveHero).Xv MOD 2 + 1
                        Hero(ActiveHero).Yv = Hero(ActiveHero).Yv MOD 2 + 1
                CASE KEYUP
                        Hero(ActiveHero).Direction = DU             'Direction=Up
                        Engine.UpdatePlayer Hero(ActiveHero), DU    'Update Player position
                        Engine.UpdateCamera Level, Hero(ActiveHero) 'Update camera position
                CASE KEYDOWN
                        Hero(ActiveHero).Direction = DD
                        Engine.UpdatePlayer Hero(ActiveHero), DD
                        Engine.UpdateCamera Level, Hero(ActiveHero)
                CASE KEYRIGHT
                        Hero(ActiveHero).Direction = DR
                        Engine.UpdatePlayer Hero(ActiveHero), DR
                        Engine.UpdateCamera Level, Hero(ActiveHero)
                CASE KEYLEFT
                        Hero(ActiveHero).Direction = DL
                        Engine.UpdatePlayer Hero(ActiveHero), DL
                        Engine.UpdateCamera Level, Hero(ActiveHero)
                CASE ELSE
        END SELECT

LOOP UNTIL Finished



END SUB

'* MakeImageIndex() subroutine:
'* Constructs an image position index for the images held in an image array.
'*
'* Parameters:
'* ImageArray() - Dynamic, integer array holding images to be indexed.
'* IndexArray() - Dynamic, integer array to hold the index for images in
'*                ImageArray().
'*
SUB MakeImageIndex (ImageArray(), IndexArray())

    'The index will initially be built in a temporary array, allowing
    'for the maximum 1000 images per file.
    DIM Temp(1 TO 1000)
    Ptr& = 1: IndexNo = 1: LastInt = UBOUND(ImageArray)
    DO
        Temp(IndexNo) = Ptr&
        IndexNo = IndexNo + 1

        'Evaluate descriptor of currently referenced image to
        'calculate the beginning of the next image.
        X& = (ImageArray(Ptr&) \ 8) * (ImageArray(Ptr& + 1)) + 4
        IF X& MOD 2 THEN X& = X& + 1
        Ptr& = Ptr& + (X& \ 2)
    LOOP WHILE Ptr& < LastInt

    LastImage = IndexNo - 1

    'Copy the image index values into the actual index array.
    REDIM IndexArray(1 TO LastImage)
    FOR n = 1 TO LastImage
        IndexArray(n) = Temp(n)
    NEXT n

END SUB

SUB Rel.AddByte (IntVal, LowByte, HiByte, ByteFlag) STATIC
'Adds a Byte or two Bytes to an Integer value
'Used for memory saving :*)

'IntVal=Value  of Integer to Pad
'ByteVal1=Value of first byte
'ByteVal2=Value of second byte
'ByteFlag=check to see if both or first or second only byte to add
'IF ByteFlag:
'0=Add Both Bytes
'1=Add the Low Byte
'2=Add the Hi Byte

FB = IntVal \ 256
SB = IntVal AND 255

SELECT CASE ByteFlag
        CASE 0     'Add both bytes
                IntVal = (HiByte * 256) OR LowByte
        CASE 1     'Add only the Low byte
                IntVal = (FB * 256) OR LowByte
        CASE 2     'Add only the Hi byte
                IntVal = (HiByte * 256) OR SB
        CASE ELSE
                IntVal = (HiByte * 256) OR LowByte
END SELECT

END SUB

SUB Rel.Box (VideoBuf(), X1, Y1, X2, Y2, CLR)
'Draws a Box to Videobuff in color Clr
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

ClipX = 0
ClipY = 0
CropX = 0
CropY = 0


'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)

'Clip or Crop
IF By1 < 0 THEN
        IF By1 + Dy < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
        ClipY = -1
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN
                Dy = Dy - (Ndy - Scr.Ymax)
                CropY = -1
        END IF
END IF

IF Bx1 < 0 THEN
        IF Bx1 + Dx < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
        ClipX = -1
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN
                Dx = Dx - (Ndx - Scr.Xmax)
                CropX = -1
        END IF
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

'Top Line
IF NOT ClipY THEN
        FOR Xa = 0 TO Dx
                POKE VpSaddr& + Xa, CLR
        NEXT Xa
END IF

'Mid Vertlines
FOR Ya = 0 TO Dy
        IF NOT ClipX THEN POKE VpSaddr&, CLR
        IF NOT CropX THEN POKE VpSaddr& + Dx, CLR
        VpSaddr& = VpSaddr& + (Scr.Xmax + 1)
NEXT Ya

'Correct Address
VpSaddr& = VpSaddr& - (Scr.Xmax + 1)
'Bottom Line
IF NOT CropY THEN
        FOR Xa = 0 TO Dx
                POKE VpSaddr& + Xa, CLR
        NEXT Xa
END IF


DEF SEG

END SUB

SUB Rel.BoxF (VideoBuf(), X1, Y1, X2, Y2, CLR)

'Draws a filled Box to Videobuff in color Clr
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Filled Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)
'Clip or Crop
IF By1 < 0 THEN
        IF Dy + By1 < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN Dy = Dy - (Ndy - Scr.Ymax)
END IF

IF Bx1 < 0 THEN
        IF Dx + Bx1 < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN Dx = Dx - (Ndx - Scr.Xmax)
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Dy
FOR Xa = 0 TO Dx
        POKE VpSaddr& + Xa, CLR
NEXT Xa
        VpSaddr& = VpSaddr& + Scr.Xmax + 1
NEXT Ya

DEF SEG

END SUB

SUB Rel.BoxFT (VideoBuf(), X1, Y1, X2, Y2, CLR)
'Draws a Filled Box to Videobuff in color Clr. Translucently!!!
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Filled Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)
'Clip or Crop
IF By1 < 0 THEN
        IF Dy + By1 < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN Dy = Dy - (Ndy - Scr.Ymax)
END IF

IF Bx1 < 0 THEN
        IF Dx + Bx1 < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN Dx = Dx - (Ndx - Scr.Xmax)
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

TempC = CLR AND 15
BaseColor = CLR - TempC

FOR Ya = 0 TO Dy
FOR Xa = 0 TO Dx
        DestCol = PEEK(VpSaddr& + Xa) AND 15
        C = ((TempC + DestCol) \ 2) + BaseColor
        POKE VpSaddr& + Xa, C
NEXT Xa
        VpSaddr& = VpSaddr& + Scr.Xmax + 1
NEXT Ya

DEF SEG


END SUB

SUB Rel.BoxT (VideoBuf(), X1, Y1, X2, Y2, CLR)
'Draws a Box to Videobuff in color Clr. Translucently!!!
'Swaps coords if not in order
'Supports clipping!!!!

'puts a Box to page
Bx1 = X1
BX2 = X2
By1 = Y1
By2 = Y2

ClipX = 0
ClipY = 0
CropX = 0
CropY = 0


'Swap values if necessary
IF Bx1 > BX2 THEN SWAP Bx1, BX2
IF By1 > By2 THEN SWAP By1, By2

Dx = (BX2 - Bx1)
Dy = (By2 - By1)

'Clip or Crop
IF By1 < 0 THEN
        IF By1 + Dy < 0 THEN
                EXIT SUB
        ELSE
                Dy = Dy + By1
        END IF
        By1 = 0
        ClipY = -1
ELSEIF By1 > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = By1 + Dy
        IF Ndy > Scr.Ymax THEN
                Dy = Dy - (Ndy - Scr.Ymax)
                CropY = -1
        END IF
END IF

IF Bx1 < 0 THEN
        IF Bx1 + Dx < 0 THEN
                EXIT SUB
        ELSE
                Dx = Dx + Bx1
        END IF
        Bx1 = 0
        ClipX = -1
ELSEIF Bx1 > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = Bx1 + Dx
        IF Ndx > Scr.Xmax THEN
                Dx = Dx - (Ndx - Scr.Xmax)
                CropX = -1
        END IF
END IF


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = YsegLUT(By1) + Bx1 + VARPTR(VideoBuf(2))

TempC = CLR AND 15
BaseColor = CLR - TempC

'Top Line
IF NOT ClipY THEN
        FOR Xa = 0 TO Dx
                DestCol = PEEK(VpSaddr& + Xa) AND 15
                POKE VpSaddr& + Xa, ((DestCol + TempC) \ 2) + BaseColor
        NEXT Xa
END IF

'Mid Vertlines
FOR Ya = 0 TO Dy
        IF NOT ClipX THEN
                DestCol = PEEK(VpSaddr&) AND 15
                POKE VpSaddr&, ((DestCol + TempC) \ 2) + BaseColor
        END IF
        IF NOT CropX THEN
                DestCol = PEEK(VpSaddr& + Dx) AND 15
                POKE VpSaddr& + Dx, ((DestCol + TempC) \ 2) + BaseColor
        END IF
        VpSaddr& = VpSaddr& + (Scr.Xmax + 1)
NEXT Ya

'Correct Address
VpSaddr& = VpSaddr& - (Scr.Xmax + 1)
'Bottom Line
IF NOT CropY THEN
        FOR Xa = 0 TO Dx
                DestCol = PEEK(VpSaddr& + Xa) AND 15
                POKE VpSaddr& + Xa, ((DestCol + TempC) \ 2) + BaseColor
        NEXT Xa
END IF


DEF SEG


END SUB

FUNCTION Rel.Collide (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Returns the color of the collided color in videobuf
'used for collision detection

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT FUNCTION
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT FUNCTION
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                BuffCol = PEEK(StartPageOff + Xa)
                IF BuffCol THEN
                        Rel.Collide = BuffCol
                        EXIT FUNCTION
                END IF
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG
Rel.Collide = 0

END FUNCTION

SUB Rel.CopyPage (DestBuffer(), SrcBuffer())
'Copies the value of SrcBuffer to DestBuffer
'very fast screen refresh

MaxElem = UBOUND(DestBuffer)
FOR I = 0 TO MaxElem
        DestBuffer(I) = SrcBuffer(I)
NEXT I

END SUB

SUB Rel.Ellipse (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, CLR)
'Original Code by Rich Geldreich
'Taken from the ABC packets and converted by me :*)
'Draws an ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'Clipping supported!!!

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))


  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.Line VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, CLR
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.Line VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, CLR
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse

          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipse

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipse
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipse
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipse

  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse

          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipse
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipse
  END IF

DEF SEG

EXIT SUB

PutPixelEllipse:

NotClip = (((Xput < 0) + (Yput < 0) + (Xput > Scr.Xmax) + (Yput > Scr.Ymax)) = 0)
IF NotClip THEN POKE YsegLUT(Yput) + Xput + VpSaddr, CLR

RETURN

END SUB

SUB Rel.EllipseF (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, CLR)
'Draws a filled ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'Clipping supported!!!

  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.Line VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, CLR
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.Line VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, CLR
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
          Rel.Line VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, CLR
          Rel.Line VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, CLR
          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.Line VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, CLR
          Rel.Line VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, CLR
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.Line VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, CLR
          Rel.Line VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, CLR
  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, CLR
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, CLR
          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, CLR
          Rel.Line VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, CLR
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.Line VideoBuf(), Xcenter, Ycenter + X, Xcenter, Ycenter + X, CLR
          Rel.Line VideoBuf(), Xcenter, Ycenter - X, Xcenter, Ycenter - X, CLR
  END IF

END SUB

SUB Rel.EllipseFT (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, CLR)
'Draws a filled ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'translucently!!!! Clipping supported!!!

  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.LineT VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, CLR
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.LineT VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, CLR
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, CLR
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, CLR
          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter + Y, Xcenter - X, Ycenter + Y, CLR
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter - Y, Xcenter - X, Ycenter - Y, CLR
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, CLR
          Rel.LineT VideoBuf(), Xcenter + X, Ycenter, Xcenter - X, Ycenter, CLR
  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, CLR
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, CLR
          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter + X, Xcenter - Y, Ycenter + X, CLR
          Rel.LineT VideoBuf(), Xcenter + Y, Ycenter - X, Xcenter - Y, Ycenter - X, CLR
      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
          Rel.LineT VideoBuf(), Xcenter, Ycenter + X, Xcenter, Ycenter + X, CLR
          Rel.LineT VideoBuf(), Xcenter, Ycenter - X, Xcenter, Ycenter - X, CLR
  END IF

END SUB

SUB Rel.EllipseT (VideoBuf(), Xcenter, Ycenter, Xrad, Yrad, CLR)
'Original Code by Rich Geldreich
'Taken from the ABC packets and converted by me :*)
'Draws an ellipse with Xcenter and Ycenter as the centercoords
'with radius of Xrad and Yrad,. if xrad=yrad then a circle is drawn
'Translucently!!!Clipping supported!!!

DIM Address AS LONG

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))

TempC = CLR AND 15
BaseColor = CLR - TempC



  DIM xe AS LONG, ye AS LONG, e AS LONG
  IF Yrad = 0 THEN 'special cases for horizontal & vertical ellipses
    Rel.LineT VideoBuf(), Xcenter - Xrad, Ycenter, Xcenter + Xrad, Ycenter, CLR
    EXIT SUB
  END IF
  IF Xrad = 0 THEN
    Rel.LineT VideoBuf(), Xcenter, Ycenter - Yrad, Xcenter, Ycenter + Yrad, CLR
    EXIT SUB
  END IF
  'work with largest axis to avoid rounding errors
  IF Yrad <= Xrad THEN
    X = 0: Y = Yrad
    xe = 0: ye = CLNG(Xrad) * Xrad
    e = -ye \ 2: C = ye \ Yrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT

          X = X + 1
          xe = xe + Yrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter + Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter - Y
          GOSUB PutPixelEllipseT

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - X
                  Yput = Ycenter
          GOSUB PutPixelEllipseT

  ELSE
    X = 0: Y = Xrad
    xe = 0: ye = CLNG(Yrad) * Yrad
    e = -ye \ 2: C = ye \ Xrad
    DO
      IF e <= 0 THEN
        DO
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT

          X = X + 1
          xe = xe + Xrad
          e = e + xe
        LOOP WHILE e <= 0
      ELSE
                  Xput = Xcenter + Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter + Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter - Y
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT

      END IF
      Y = Y - 1
      ye = ye - C
      e = e - ye
    LOOP UNTIL Y = 0
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter
                  Yput = Ycenter + X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
                  Xput = Xcenter
                  Yput = Ycenter - X
          GOSUB PutPixelEllipseT
  END IF

DEF SEG

EXIT SUB

PutPixelEllipseT:

NotClip = (((Xput < 0) + (Yput < 0) + (Xput > Scr.Xmax) + (Yput > Scr.Ymax)) = 0)
IF NotClip THEN
        Address = YsegLUT(Yput) + Xput + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((DestColor + TempC) \ 2) + BaseColor
END IF

RETURN

END SUB

SUB Rel.Fade (R, G, B, Counts) STATIC
'This sub fades the current palette to the specified RGB color
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?


TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE

ColorVal = 0
 
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

IF Counts < 1 THEN Counts = 1
'Morphing algorithm used  yay!!!!
FOR I = 0 TO 255
        PalDiff = R - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = G - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = B - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = 0 TO 255
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        OUT &H3C8, 0
        FOR J = 0 TO 255
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE FadePal


END SUB

SUB Rel.FadeStep (StartCol, EndCol, R%, G%, B%) STATIC
'This sub fades the current palette to the specified RGB color
'in steps, so if you want to fade fully call this sub 64 times
'from StartColor to Endcolor ie, selective fade

IF StartCol > EndCol THEN SWAP StartCol, EndCol

I = I + 1

IF I > 63 THEN
        I = 0
        EXIT SUB
END IF

FOR J = StartCol TO EndCol


        Rel.ReadRGB J, RD, GN, BLL

        IF R% > RD THEN
                RD = RD + 1
        ELSEIF R% < RD THEN
                RD = RD - 1
        ELSE
                'Do nothing
        END IF

        IF G% > GN THEN
                GN = GN + 1
        ELSEIF G% < GN THEN
                GN = GN - 1
        ELSE
                'Do nothing
        END IF

        IF B% > BLL THEN
                BLL = BLL + 1
        ELSEIF B% < BLL THEN
                BLL = BLL - 1
        ELSE
                'Do nothing
        END IF

        Rel.WriteRGB J, RD, GN, BLL

NEXT J

END SUB

SUB Rel.FadeToPal (PalString$, Counts) STATIC
'This sub fades the current palette to the specified palette comtained
'in the 768 byte palstring$
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?

TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE      'Current pal
REDIM TempPalArray2(2, 255) AS SINGLE     'PalString$ pal
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE


ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray2(0, ColorVal) = ASC(MID$(PalString$, I%, 1))
    TempPalArray2(1, ColorVal) = ASC(MID$(PalString$, I% + 1, 1))
    TempPalArray2(2, ColorVal) = ASC(MID$(PalString$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%


IF Counts < 1 THEN Counts = 1

'Morphing algorithm used  yay!!!!
FOR I = 0 TO 255
        PalDiff = TempPalArray2(0, I) - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = TempPalArray2(1, I) - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = TempPalArray2(2, I) - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = 0 TO 255
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        OUT &H3C8, 0
        FOR J = 0 TO 255
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE TempPalArray2
ERASE FadePal


END SUB

SUB Rel.FadeToPalStep (StartCol, EndCol, PalString$) STATIC

'This sub fades the current palette to the palette in the
'768 byte Palstring$
'in steps, so if you want to fade fully call this sub 64 times
'from StartColor to Endcolor ie, selective fade

PalI = PalI + 1

IF PalI > 63 THEN
        PalI = 0
        EXIT SUB
END IF


REDIM TempPalArray(2, 255) AS INTEGER      'Current pal

ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(PalString$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(PalString$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(PalString$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%


IF StartCol > EndCol THEN SWAP StartCol, EndCol


FOR J = StartCol TO EndCol


        Rel.ReadRGB J, RD, GN, BLL
        R% = TempPalArray(0, J)
        IF R% > RD THEN
                RD = RD + 1
        ELSEIF R% < RD THEN
                RD = RD - 1
        ELSE
                'Do nothing
        END IF

        G% = TempPalArray(1, J)
        IF G% > GN THEN
                GN = GN + 1
        ELSEIF G% < GN THEN
                GN = GN - 1
        ELSE
                'Do nothing
        END IF

        B% = TempPalArray(2, J)
        IF B% > BLL THEN
                BLL = BLL + 1
        ELSEIF B% < BLL THEN
                BLL = BLL - 1
        ELSE
                'Do nothing
        END IF

        Rel.WriteRGB J, RD, GN, BLL

NEXT J

ERASE TempPalArray


END SUB

SUB Rel.FadeToPalX (StartCol, EndCol, PalString$, Counts) STATIC

'This sub fades the current palette to the specified palette comtained
'in the 768 byte palstring$ form Start col to endcol
'ie selective fade
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?

TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE      'Current pal
REDIM TempPalArray2(2, 255) AS SINGLE     'PalString$ pal
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE


ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

ColorVal = 0
FOR I% = 1 TO 768 STEP 3
    TempPalArray2(0, ColorVal) = ASC(MID$(PalString$, I%, 1))
    TempPalArray2(1, ColorVal) = ASC(MID$(PalString$, I% + 1, 1))
    TempPalArray2(2, ColorVal) = ASC(MID$(PalString$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%


IF Counts < 1 THEN Counts = 1

'Morphing algorithm used  yay!!!!
IF StartCol > EndCol THEN SWAP StartCol, EndCol
FOR I = StartCol TO EndCol
        PalDiff = TempPalArray2(0, I) - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = TempPalArray2(1, I) - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = TempPalArray2(2, I) - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = StartCol TO EndCol
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        FOR J = StartCol TO EndCol
                OUT &H3C8, J
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE TempPalArray2
ERASE FadePal

END SUB

SUB Rel.FadeX (StartCol, EndCol, R, G, B, Counts) STATIC
'This sub fades the current palette to the specified RGB color
'from StartColor to Endcolor ie, selective fade
'counts is a nifty idea that lets you specify how many iterations
'to fade b4 it ends, cool huh?


TempPal$ = SPACE$(768)
Rel.ReadPal TempPal$
REDIM TempPalArray(2, 255) AS SINGLE
REDIM FadePal(2, 255) AS SINGLE
DIM PalDiff AS SINGLE

ColorVal = 0

FOR I% = 1 TO 768 STEP 3
    TempPalArray(0, ColorVal) = ASC(MID$(TempPal$, I%, 1))
    TempPalArray(1, ColorVal) = ASC(MID$(TempPal$, I% + 1, 1))
    TempPalArray(2, ColorVal) = ASC(MID$(TempPal$, I% + 2, 1))
    ColorVal = ColorVal + 1
NEXT I%

IF Counts < 1 THEN Counts = 1
'Morphing algorithm used  yay!!!!
IF StartCol > EndCol THEN SWAP StartCol, EndCol

FOR I = StartCol TO EndCol
        PalDiff = R - TempPalArray(0, I)
        FadePal(0, I) = PalDiff / Counts

        PalDiff = G - TempPalArray(1, I)
        FadePal(1, I) = PalDiff / Counts

        PalDiff = B - TempPalArray(2, I)
        FadePal(2, I) = PalDiff / Counts
NEXT I

FOR I = 1 TO Counts
        FOR J = StartCol TO EndCol
                TempPalArray(0, J) = TempPalArray(0, J) + FadePal(0, J)
                TempPalArray(1, J) = TempPalArray(1, J) + FadePal(1, J)
                TempPalArray(2, J) = TempPalArray(2, J) + FadePal(2, J)
        NEXT J

        WAIT &H3DA, 8, 8
        WAIT &H3DA, 8

        FOR J = StartCol TO EndCol
                OUT &H3C8, J
                OUT &H3C9, TempPalArray(0, J)
                OUT &H3C9, TempPalArray(1, J)
                OUT &H3C9, TempPalArray(2, J)
        NEXT J

NEXT I

ERASE TempPalArray
ERASE FadePal

END SUB

FUNCTION Rel.FastKB STATIC
'Faster replacement for inkey$
'Break codes(Scancode+128) from 215 are ignored.
'returns the scancode for the pressed key
'the list of scancodes can be found at QB's help file.
IF NOT KeyReProg THEN
        OUT &H60, &HF3                          'Inform keyboard
        FOR Delay& = 1 TO 1000: NEXT Delay&      'Just a precaution(Settle)
        OUT &H60, 0                             'send fast typematic rate
        KeyReProg = -1
END IF

        Code = INP(&H60)
        IF Code > 215 THEN
                Rel.FastKB = OldCode
        ELSE
                Rel.FastKB = Code
                OldCode = Code
        END IF

        'Memory 40:1A/1C
        'What this does is point the head to tail of the key buffer
        DEF SEG = &H40                  'Clears the pending key buffer
        POKE &H1A, PEEK(&H1C)           'Set head pointer to buffer start...
                                        'For the annoying beep :*)

END FUNCTION

SUB Rel.Font (VideoBuf(), X%, Y%, Text$, Centered%, FontArray(), FontArrayIndex())
'Prints a font in Pseudo true-type columns to videobuf
'Text$=is the string to print
'X,Y are the top left coords(in pixel) of the string
'if Centered then the string is printed at the center
'Font() and FontArray() are PP256 made index
'to make your own fonts, use PP256's tile editor :*)

XX% = X%
YY% = Y%
IF NOT Centered% THEN

        FOR I% = 1 TO LEN(Text$)
                FontChar% = ASC(MID$(Text$, I%, 1)) - 31
                Rel.Sprite VideoBuf(), XX%, YY%, FontArray(), FontArrayIndex(FontChar)
                XX% = XX% + (FontArray(FontArrayIndex(FontChar%)) \ 8)
        NEXT I%

ELSE            'Centered

        StrLen% = 0
        FOR I% = 1 TO LEN(Text$)
                FontChar% = ASC(MID$(Text$, I%, 1)) - 31
                StrLen% = StrLen% + (FontArray(FontArrayIndex(FontChar%)))
        NEXT I%
        StrLen% = StrLen% \ 8  'Calculate length
        XX% = ((Scr.Xmax + 1) - StrLen%) \ 2
        FOR I% = 1 TO LEN(Text$)
                FontChar% = ASC(MID$(Text$, I%, 1)) - 31
                Rel.Sprite VideoBuf(), XX%, YY%, FontArray(), FontArrayIndex(FontChar)
                XX% = XX% + (FontArray(FontArrayIndex(FontChar%)) \ 8)
        NEXT I%

END IF

END SUB

SUB Rel.Get (VideoBuf(), X1, Y1, X2, Y2, Sprite(), SpriteOffset)
'Works like QB's GET statement
'the array made is QB GET/PUT compatible
'gets the sprite from X1,Y1,X2,Y2 from VideoBuff
'and puts the values into Sprite with an offset of SpriteOffset.

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = (X2 - X1) + 1
oYsize = (Y2 - Y1) + 1
Xsize = oXsize
Ysize = oYsize

NewX = X1
NewY = Y1

ScrXlen = Scr.Xmax + 1


SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))

'Save Width
Sprite(SpriteOffset) = Xsize * 8
'Save Height
Sprite(SpriteOffset + 1) = Ysize


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF

BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = BuffSeg
        CLR = PEEK(StartPageOff + Xa)
        DEF SEG = SprSeg
        POKE SprOff + Xa, CLR
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.KgenFont (VideoBuf(), X, Y, Font$, MinColor, Italic)
'=======Prints system fonts on VideoBufn  specified by X,Y
'=======Uses 8 colors from mincolor to Mincolor+8
'=======Font$ is the string, italic? Duh!!!!!
'======================================================

DIM e(7): e(0) = 1: FOR F = 1 TO 7: e(F) = e(F - 1) + e(F - 1): NEXT F


XXX = X
YYY = Y

IF X = Scr.Xmax + 1 THEN X = ((Scr.Xmax + 1) \ 2) - (4 * LEN(Font$))

DEF SEG = &HFFA6
FOR A = 1 TO LEN(Font$)
KC = 0
IF Italic THEN
        Ita = 8
ELSE
        Ita = 0
END IF

 X = X + 8
 d = ASC(MID$(Font$, A, 1)) * 8 + 14
 FOR B = 0 TO 7
  FOR C = 0 TO 7
   IF PEEK(B + d) AND e(C) THEN
        DEF SEG = VARSEG(VideoBuf(0))
        NotClip = (((((X - C) + Ita) < 0) + ((Y + B) < 0) + (((X - C) + Ita) > Scr.Xmax) + ((Y + B) > Scr.Ymax)) = 0)
        IF NotClip THEN POKE YsegLUT((Y + B)) + ((X - C) + Ita) + VARPTR(VideoBuf(2)), MinColor + KC
        DEF SEG = &HFFA6
   END IF
  NEXT C
        KC = KC MOD 8 + 1
           IF Italic THEN
                Ita = Ita - 1
           END IF
 NEXT B
NEXT A

DEF SEG

X = XXX
Y = YYY

END SUB

SUB Rel.Line (VideoBuf(), X, Y, X2, Y2, CLR)
'Original Code by Kurt Kuzba
'Taken from the ABC packets and converted by me :*)
'Draws a Diagonal line specified by X,Y,X2,Y2
'Clipping Supported and Swaps values which are not in order.


DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))

I = 0
Slope = 0
Eterm = 0

IF (X2 - X) > 0 THEN
     SX = 1
ELSE
     SX = -1
END IF
Dx = ABS(X2 - X)


IF (Y2 - Y) > 0 THEN
     SY = 1
ELSE
     SY = -1
END IF
Dy = ABS(Y2 - Y)

IF (Dy > Dx) THEN
        Slope = 1
        SWAP X, Y
        SWAP Dx, Dy
        SWAP SX, SY
END IF
Eterm = 2 * Dy - Dx

FOR I = 0 TO Dx - 1
   IF Slope = 1 THEN
     NotClip = (((Y < 0) + (X < 0) + (Y > Scr.Xmax) + (X > Scr.Ymax)) = 0)
     IF NotClip THEN POKE YsegLUT(X) + Y + VpSaddr, CLR
   ELSE
     NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
     IF NotClip THEN POKE YsegLUT(Y) + X + VpSaddr, CLR
   END IF

   WHILE Eterm >= 0
      Y = Y + SY: Eterm = Eterm - 2 * Dx
   WEND
   X = X + SX: Eterm = Eterm + 2 * Dy
NEXT
     NotClip = (((X2 < 0) + (Y2 < 0) + (X2 > Scr.Xmax) + (Y2 > Scr.Ymax)) = 0)
     IF NotClip THEN POKE YsegLUT(Y2) + X2 + VpSaddr, CLR

DEF SEG

END SUB

SUB Rel.LineT (VideoBuf(), X, Y, X2, Y2, CLR)
'Original Code by Kurt Kuzba
'Taken from the ABC packets and converted by me :*)
'Draws a Diagonal line specified by X,Y,X2,Y2. Translucently!!!
'Clipping Supported and Swaps values which are not in order.


DIM Address AS LONG
DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))

I = 0
Slope = 0
Eterm = 0

TempC = CLR AND 15
BaseColor = CLR - TempC

IF (X2 - X) > 0 THEN
     SX = 1
ELSE
     SX = -1
END IF
Dx = ABS(X2 - X)


IF (Y2 - Y) > 0 THEN
     SY = 1
ELSE
     SY = -1
END IF
Dy = ABS(Y2 - Y)

IF (Dy > Dx) THEN
        Slope = 1
        SWAP X, Y
        SWAP Dx, Dy
        SWAP SX, SY
END IF
Eterm = 2 * Dy - Dx

FOR I = 0 TO Dx - 1
   IF Slope = 1 THEN
     NotClip = (((Y < 0) + (X < 0) + (Y > Scr.Xmax) + (X > Scr.Ymax)) = 0)
     IF NotClip THEN
        Address = YsegLUT(X) + Y + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((TempC + DestColor) \ 2) + BaseColor
     END IF
   ELSE
     NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
     IF NotClip THEN
        Address = YsegLUT(Y) + X + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((TempC + DestColor) \ 2) + BaseColor
     END IF
   END IF

   WHILE Eterm >= 0
      Y = Y + SY: Eterm = Eterm - 2 * Dx
   WEND
   X = X + SX: Eterm = Eterm + 2 * Dy
NEXT
     NotClip = (((X2 < 0) + (Y2 < 0) + (X2 > Scr.Xmax) + (Y2 > Scr.Ymax)) = 0)
     IF NotClip THEN
        Address = YsegLUT(Y2) + X2 + VpSaddr
        DestColor = PEEK(Address) AND 15
        POKE Address, ((TempC + DestColor) \ 2) + BaseColor
     END IF

DEF SEG

END SUB

SUB Rel.LoadPal (File$, PalString$, Switch) STATIC
'Loads a 768 pal to PalString$
'File$=File to load
'PalString$=768 byte pal
'Switch=Flag to switch the current pal to palstring$
'any non-zero for switch will change the current pal

 IF INSTR(File$, ".") = 0 THEN File$ = File$ + ".RGB"

    TempPal$ = SPACE$(768)

    FileNum% = FREEFILE
    OPEN File$ FOR BINARY AS #FileNum%
        GET #FileNum%, , TempPal$
    CLOSE #FileNum%

    IF LEN(TempPal$) <> 768 THEN EXIT SUB



IF Switch THEN

    OUT &H3C8, 0
    FOR I% = 1 TO 768 STEP 3
        OUT &H3C9, ASC(MID$(TempPal$, I%, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 1, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 2, 1))
    NEXT I%

END IF

PalString$ = TempPal$

END SUB

SUB Rel.LoadPalPp256 (File$) STATIC
'Loads and Switches the pal to PP256's pal from File$
'Special thanks goes to Kackurot for this one.

FR = FREEFILE
IF INSTR(File$, ".") = 0 THEN File$ = LEFT$(File$, 8) + ".Pal"
OPEN File$ FOR BINARY AS #FR
    FOR n = 0 TO 255
        GET #FR, , C&
        B = C& \ 65536: C& = C& - B * 65536
        G = C& \ 256: C& = C& - G * 256
        R = C&
        OUT &H3C8, n
        OUT &H3C9, R
        OUT &H3C9, G
        OUT &H3C9, B
     NEXT
CLOSE #FR

END SUB

SUB Rel.NegativePal STATIC
'Makes a seemingly negative effect on the current palette
'very cool!!!

FOR I% = 0 TO 255

 Rel.ReadRGB I%, R%, G%, B%
 Rel.WriteRGB I%, 63 - R%, 63 - G%, 63 - B%

NEXT I%

END SUB

SUB Rel.PageClear (VideoBuf() AS INTEGER) STATIC
'Clears the screen to 0
'Very fast!!!! use this instead of Rel.Cls if you want to clear to color 0

PageL = VideoBuf(0)
PageH = VideoBuf(1)
REDIM VideoBuf(32002) AS INTEGER
VideoBuf(0) = PageL
VideoBuf(1) = PageH
END SUB

SUB Rel.PageCls (VideoBuf(), CLR) STATIC

'Clears the page to color
DEF SEG = VARSEG(VideoBuf(0))
VpSaddr& = VARPTR(VideoBuf(2))

        FOR Y = 0 TO Scr.Ymax
        FOR X = 0 TO Scr.Xmax
                POKE X + VpSaddr&, CLR
        NEXT X
                VpSaddr& = VpSaddr& + Scr.Xmax + 1
        NEXT Y
DEF SEG

END SUB

SUB Rel.PageInit (VideoBuf(), Xmax, Ymax) STATIC
'Initializes the dimensions of a page
'and initializes the current page

Scr.Xmax = Xmax
Scr.Ymax = Ymax

'Initializes the lookup table for speed purposes
'Ysegment LUT
FOR I = 0 TO 199
        YsegLUT(I) = I * (Scr.Xmax + 1&)
NEXT I

Xmax& = Scr.Xmax
Ymax& = Scr.Ymax

Size = ((Xmax& + 1) * (Ymax& + 1) + 4) \ 2


REDIM VideoBuf(Size)

'initializes the page
GET (0, 0)-(Scr.Xmax, Scr.Ymax), VideoBuf



END SUB

SUB Rel.PageVideoCopy (X, Y, VideoBuf(), Action) STATIC
'Copies the contents of the page to the screen
'very fast as this uses the normal QB put routine ;-)
'Use Action=1 as much as possible.

SELECT CASE Action
        CASE 1
                PUT (X, Y), VideoBuf, PSET
        CASE 2
                PUT (X, Y), VideoBuf, AND
        CASE 3
                PUT (X, Y), VideoBuf, OR
        CASE 4
                PUT (X, Y), VideoBuf, XOR
        CASE ELSE
END SELECT
END SUB

FUNCTION Rel.Point (VideoBuf(), X, Y)
'Works like QB's Point function

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))
NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
IF NotClip THEN
        Rel.Point = PEEK(YsegLUT(Y) + X + VpSaddr)
ELSE
        Rel.Point = 0
END IF
DEF SEG

END FUNCTION

SUB Rel.Pset (VideoBuf(), X, Y, CLR) STATIC
'Puts a pixel to page
'Clipping supported!!!

DEF SEG = VARSEG(VideoBuf(0))
VpSaddr = VARPTR(VideoBuf(2))
NotClip = (((X < 0) + (Y < 0) + (X > Scr.Xmax) + (Y > Scr.Ymax)) = 0)
IF NotClip THEN POKE YsegLUT(Y) + X + VpSaddr, CLR
DEF SEG
END SUB

SUB Rel.ReadPal (PalString$) STATIC
'Reads the current palette and puts it to a 768 byte string
'palstring$, use this if you loaded the pal from a pp256 format

TempPal$ = SPACE$(768)

OUT &H3C7, 0
FOR I% = 0 TO 255
  MID$(TempPal$, (I% * 3) + 1, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 2, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 3, 1) = CHR$(INP(&H3C9))
NEXT I%

PalString$ = TempPal$

END SUB

SUB Rel.ReadRGB (ColorVal, R, G, B) STATIC
'Reads the RGB values of the color and puts them to R,G, and B.
        OUT &H3C7, ColorVal
        R = INP(&H3C9)
        G = INP(&H3C9)
        B = INP(&H3C9)
END SUB

SUB Rel.RotatePalB (StartCol, EndCol) STATIC
'Rotates the pal Backwards
'colors affected are from Startcol to Endcol

IF StartCol > EndCol THEN SWAP StartCol, EndCol

REDIM TempPal(2, StartCol TO EndCol) AS INTEGER

FOR I = StartCol TO EndCol
        Rel.ReadRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I
FOR I = StartCol TO EndCol - 1
        SWAP TempPal(0, I), TempPal(0, I + 1)
        SWAP TempPal(1, I), TempPal(1, I + 1)
        SWAP TempPal(2, I), TempPal(2, I + 1)
NEXT I

FOR I = StartCol TO EndCol
        Rel.WriteRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I
ERASE TempPal

END SUB

SUB Rel.RotatePalF (StartCol, EndCol) STATIC
'Rotates the pal Forward
'colors affected are from Startcol to Endcol

IF StartCol > EndCol THEN SWAP StartCol, EndCol

REDIM TempPal(2, StartCol TO EndCol) AS INTEGER

FOR I = StartCol TO EndCol
        Rel.ReadRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I
FOR I = EndCol TO StartCol + 1 STEP -1
        SWAP TempPal(0, I), TempPal(0, I - 1)
        SWAP TempPal(1, I), TempPal(1, I - 1)
        SWAP TempPal(2, I), TempPal(2, I - 1)
NEXT I

FOR I = StartCol TO EndCol
        Rel.WriteRGB I, TempPal(0, I), TempPal(1, I), TempPal(2, I)
NEXT I

ERASE TempPal

END SUB

SUB Rel.SavePal (File$) STATIC
'Saves the current palette to a file.

IF INSTR(File$, ".") = 0 THEN File$ = LEFT$(File$, 8) + ".Pal"

TempPal$ = SPACE$(768)

OUT &H3C7, 0
FOR I% = 0 TO 255
  MID$(TempPal$, (I% * 3) + 1, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 2, 1) = CHR$(INP(&H3C9))
  MID$(TempPal$, (I% * 3) + 3, 1) = CHR$(INP(&H3C9))
NEXT I%

FileNum% = FREEFILE
OPEN File$ FOR BINARY AS #FileNum%
PUT #FileNum%, , TempPal$
CLOSE #FileNum%

END SUB

SUB Rel.SetActivePage (VideoBuf())
'Sets the active page
'use this in mutiple page'd programs.
'all writes like Rel.Sprite,Rel.Pset are to VideoBuf()
'after the call unless you set the active page to another page()

Scr.Xmax = (VideoBuf(0) \ 8) - 1
Scr.Ymax = VideoBuf(1) - 1

'Initializes the lookup table for speed purposes
'Ysegment LUT
FOR I = 0 TO Scr.Ymax
        YsegLUT(I) = I * (Scr.Xmax + 1&)
NEXT I

END SUB

FUNCTION Rel.Size (X1, Y1, X2, Y2)
'Calculates the Size of the array
'to be used in QB's GET or Rel.Get

Rel.Size = ((((X2 - X1) + 1) * ((Y2 - Y1) + 1)) + 4) \ 2

END FUNCTION

SUB Rel.Sprite (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF

BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                POKE StartPageOff + Xa, C
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG


END SUB

SUB Rel.SpriteC (VideoBuf(), X, Y, Sprite(), SpriteOffset, CLR)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking and draws the outline
'of the sprite using Clr. Used for collision detection.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                POKE StartPageOff + Xa, CLR
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.SpriteCT (VideoBuf(), X, Y, Sprite(), SpriteOffset, CLR)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking and draws the outline
'of the sprite using Clr. Translucently.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

TempC = CLR AND 15
BaseColor = CLR - TempC

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                DEF SEG = BuffSeg
                DestCol = PEEK(StartPageOff + Xa) AND 15
                C = ((TempC + DestCol) \ 2) + BaseColor
                POKE StartPageOff + Xa, C
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

END SUB

SUB Rel.SpriteG (VideoBuf(), X, Y, Sprite(), SpriteOffset, GammaVal)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking.
'Supports Clipping!!!!!
'Gammaval: if <0, draws a darkened sprite. if >0 then lightened. if 0 then normal.


DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it

IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF


IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                TempC = C AND 15
                BaseColor = C - TempC
                TempC = (TempC + GammaVal) + BaseColor
                IF TempC < BaseColor THEN
                        TempC = BaseColor
                ELSEIF TempC > BaseColor + 15 THEN
                        TempC = BaseColor + 15
                END IF
                DEF SEG = BuffSeg
                POKE StartPageOff + Xa, TempC
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.SpriteN (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Draws a GET/PUT compatible sprite at VideoBuff(). Solidly.
'at coords X,Y
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Doesn't skip color zero so this is faster
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))

FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        DEF SEG = BuffSeg
        POKE StartPageOff + Xa, C
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG



END SUB

SUB Rel.SpriteT (VideoBuf(), X, Y, Sprite(), SpriteOffset)
'Draws a GET/PUT compatible sprite at VideoBuff()
'at coords X,Y. TransLucently!!!!
'Sprite()= the array
'SpriteOffset=Index(offset) of the sprite in multiple tile arrays
'Skips color zero so no need for masking.
'Supports Clipping!!!!!

DIM StartPageOff AS LONG
DIM ScrXlen

oXsize = Sprite(SpriteOffset) \ 8
oYsize = Sprite(SpriteOffset + 1)
Xsize = oXsize
Ysize = oYsize
NewX = X
NewY = Y

SprSeg = VARSEG(Sprite(SpriteOffset))
SprOff = VARPTR(Sprite(SpriteOffset + 2))
ScrXlen = Scr.Xmax + 1


'Clip/Crop it
IF NewY < 0 THEN
        CY = -NewY
        Ysize = Ysize - CY
        NewY = 0
        SprOff = SprOff + (CY * oXsize)
ELSEIF NewY > Scr.Ymax THEN
        EXIT SUB
ELSE
        Ndy = NewY + oYsize
        IF Ndy > Scr.Ymax THEN
                Ysize = Ysize - (Ndy - (Scr.Ymax + 1))
        END IF
END IF

IF NewX < 0 THEN
        CX = -NewX
        Xsize = Xsize - CX
        NewX = 0
        SprOff = SprOff + CX
ELSEIF NewX > Scr.Xmax THEN
        EXIT SUB
ELSE
        Ndx = NewX + oXsize
        IF Ndx > Scr.Xmax THEN
                Xsize = Xsize - (Ndx - ScrXlen)
        END IF
END IF


BuffSeg = VARSEG(VideoBuf(0))
StartPageOff = YsegLUT(NewY) + NewX + VARPTR(VideoBuf(2))


FOR Ya = 0 TO Ysize - 1
FOR Xa = 0 TO Xsize - 1
        DEF SEG = SprSeg
        C = PEEK(SprOff + Xa)
        IF C THEN
                TempC = C AND 15
                BaseColor = C - TempC
                DEF SEG = BuffSeg
                DestCol = PEEK(StartPageOff + Xa) AND 15
                C = ((TempC + DestCol) \ 2) + BaseColor
                POKE StartPageOff + Xa, C
        END IF
NEXT Xa
        StartPageOff = StartPageOff + ScrXlen
        SprOff = SprOff + oXsize
NEXT Ya

DEF SEG

END SUB

SUB Rel.SwitchToPal (PalString$) STATIC
'Switch the current pal to the values held by PalString$
'instantaneously.

TempPal$ = SPACE$(768)
TempPal$ = PalString$
    OUT &H3C8, 0
    FOR I% = 1 TO 768 STEP 3
        OUT &H3C9, ASC(MID$(TempPal$, I%, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 1, 1))
        OUT &H3C9, ASC(MID$(TempPal$, I% + 2, 1))
    NEXT I%

END SUB

SUB Rel.WriteRGB (ColorNum, R, G, B) STATIC
'Writes the R,G and B values to the color Attribute changing its value.

        OUT &H3C8, ColorNum
        OUT &H3C9, R
        OUT &H3C9, G
        OUT &H3C9, B
END SUB

SUB SwitchHeroes (Active, OldActive)

Hero(Active).X = Hero(OldActive).X
Hero(Active).Y = Hero(OldActive).Y
Hero(Active).Direction = Hero(OldActive).Direction
Hero(Active).Move = Hero(OldActive).Move
Hero(Active).Frame = Hero(OldActive).Frame
Hero(Active).Move = TRUE
Engine.UpdateCamera Level, Hero(Active)
Engine.DrawScreen

END SUB

